<template>
  <a-layout-header class="header">
    <a-row class="header-row">
      <a-col :xs="24" :md="6" :lg="5" :xxl="4">
        <a href="/"><img class="logo" src="/nav-logo.png"/></a>
      </a-col>
      <a-col :xs="0" :md="18" :lg="19" :xxl="20" class="header-menu-col">
        <a-menu
          theme="dark"
          mode="horizontal"
          :selected-keys="currentlySelected"
          class="menu"
          @click="navigate"
        >
          <a-menu-item key="/cart">
            <a-icon type="shopping-cart"/>
            <span ref="cartNumber" class="cart-items-count">{{ countItemsInCart }}</span>
          </a-menu-item>
        </a-menu>
      </a-col>
    </a-row>
  </a-layout-header>
</template>
<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  name: 'navbar',
  computed: {
    countItemsInCart (): number {
      return this.$store.getters['cart/countItems']
    },
    currentlySelected (): Array<string> {
      return [this.$route.fullPath]
    }
  },
  methods: {
    navigate(args: any): void {
      this.$router.push(args.key)
    }
  },
  watch: {
    countItemsInCart: function () {
      const el = this.$refs.cartNumber
      if (!el) {
        return
      }
      //@ts-ignore
      el.classList.add('animate__animated', 'animate__heartBeat')
      //@ts-ignore
      el.addEventListener('animationend', () => {
        //@ts-ignore
        el.classList.remove('animate__animated', 'animate__heartBeat')
      })
    }
  }
})
</script>
<style lang="scss" scoped>
.logo {
  width: 100px;
  height: auto;
}

.header {
  position: fixed;
  z-index: 10;
  width: 100%;
  display: flex;
}

.menu {
  line-height: 64px;
}

.header-row {
  width: 100%;
}

.header-menu-col {
  & > * {
    float: right;
  }
}
.ant-menu-item .anticon + .cart-items-count {
  display: inline-block;
  transition-property: opacity, width, color;
  transition-duration: 0.3s, 0.3s;
  transition-timing-function: cubic-bezier(0.645, 0.045, 0.355, 1), cubic-bezier(0.645, 0.045, 0.355, 1);
  transition-delay: 0s, 0s;
  color: rgba(255, 255, 255, 0.65);
  &.animate__animated {
    color: #FFD541;
  }
}
</style>
